IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID('[dbo].[mps_sys_calc_barnpower]') AND type = 'P')
DROP PROCEDURE [dbo].[mps_sys_calc_barnpower]
GO
create procedure [dbo].[mps_sys_calc_barnpower](
@cmpid int ,
@whid int 
) as
begin
-- 计算新建人有哪些
  exec drop_temp_table '#permittion' 
  create table #permittion(ptype varchar(30), ctgid int , pid int , pobjid1 int , pobjid2 int) 
  
create table #myuser(pptype varchar(30),cuid int, grp int) 
exec mps_gen_powerusers @cmpid,0,0,0,0,0,0,0,0,
'barn',@whid,0,0,@whid,'barnview' 
declare @users table(pptype varchar(30), ppgroup int , useruid int) 
insert into @users( pptype ,ppgroup,useruid) 
select distinct    pptype  ,grp , cuid from #myuser 


drop table #myuser
exec drop_temp_table '#permittion' 

  
  -- 首先要判断一下，当前用户是否可以新建  
  
  delete mps_warehouse_users 
  where whp_whid=@whid and (not exists (select 1 from @users where pptype=whp_type and whp_cuid=useruid)) 
  
  insert into mps_warehouse_users(whp_type,whp_whid,whp_cuid)
  select distinct pptype,@whid,useruid
  from @users  
  where (not exists (select 1 from mps_warehouse_users where whp_whid=@whid and pptype=whp_type and whp_cuid=useruid)) 
  
  
  
end